unit UfrmMaitre;

// |===========================================================================|
// | UNITE UfrmMaitre                                                          |
// | dvelopp par F.BASSO 2006                                                |
// | Unit principale de l'application pcgrp                                   |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.0.0.1 Ajout d'une zone de filtre                                      |
// |===========================================================================|

interface

uses
  Windows, SysUtils,  Variants,  Graphics, Controls, Forms,
  Dialogs, StdCtrls,ufbreseau, Classes;

type
  TfrmMaitre = class(TForm)
    gbInformation: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    lbNomPc: TLabel;
    lbNomDomaine: TLabel;
    lbNomUtilisateur: TLabel;
    LBNomBDC: TLabel;
    lstListeGroupe: TListBox;
    Label5: TLabel;
    lstGroupeTotal: TListBox;
    Label6: TLabel;
    cmdAjoute: TButton;
    cmdSupprimer: TButton;
    filtre: TEdit;
    procedure cmdSupprimerClick(Sender: TObject);
    procedure cmdAjouteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure filtreChange(Sender: TObject);

  private

// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************

   listegroupe : TTabGroupe0 ;
   listegroupeg : TTabGroupeGlobaux ;
   procedure MiseAjourListeGroupe;

  public

// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************

  end;

var
  frmMaitre: TfrmMaitre;

implementation

{$R *.dfm}
Function StrLectureVersion : String;

//  ___________________________________________________________________________
// | function  StrLectureVersion                                               |
// | _________________________________________________________________________ |
// || Permet d'avoir le numero de version de l'appli                          ||
// ||_________________________________________________________________________||
// || Sorties | String                                                        ||
// ||         |   Version de l'appli                                          ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

Var
  S         : String;
  Taille    : DWord;
  Buffer    : PChar;
  VersionPC : PChar;
  VersionL  : DWord;

Begin
  Result:='';
  // On demande la taille des informations sur l'application
  S := Application.ExeName;
  Taille := GetFileVersionInfoSize(PChar(S), Taille);
  If Taille>0
  Then Try
  // Rservation en mmoire d'une zone de la taille voulue
    Buffer := AllocMem(Taille);
  // Copie dans le buffer des informations
    GetFileVersionInfo(PChar(S), 0, Taille, Buffer);
  // Recherche de l'information de version
    If VerQueryValue(Buffer, PChar('\StringFileInfo\040C04E4\FileVersion'), Pointer(VersionPC), VersionL)
      Then Result:=VersionPC;
  Finally
    FreeMem(Buffer, Taille);
  End;
End;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Prive                                                             #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure TfrmMaitre.MiseAjourListeGroupe ;
//  ___________________________________________________________________________
// | procedure TfrmMaitre.MiseAjourListeGroupe                                 |
// | _________________________________________________________________________ |
// ||   Permet d'afficher la liste des groupes en fonction du filtre et des   ||
// ||   Groupes dj affects au l'ordinateur                                 ||
// ||_________________________________________________________________________||
// || Entres |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var i : integer;
    str: string ;
    longueurfiltre : integer;
begin

// ****************************************************************************
// * Rcupration du filtre est de  longueur                                *
// ****************************************************************************

  str := filtre.text;
  longueurfiltre := length(str);
  lstGroupeTotal.Items.Clear ;

// ****************************************************************************
// * Enumration de la liste des groupes du domaine                           *
// ****************************************************************************

  for i := 0 to length(listegroupeg) - 1 do
  begin
    if lstListeGroupe.Items.IndexOf(listegroupeg[i].nom) = -1 then
    begin

// ****************************************************************************
// * Si le groupe n'est pas dj affect  l'ordinateur et qu'il commence     *
// * comme le filtre on l'affiche                                             *
// ****************************************************************************

      if str= copy(listegroupeg[i].nom,1,longueurfiltre ) then
      lstGroupeTotal.Items.Add(listegroupeg[i].nom );
    end;
  end;
end;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie Evnementiel                                                       #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#


procedure TfrmMaitre.FormCreate(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TfrmMaitre.FormCreate                                           |
// | __________________________________________________________________________|
// ||   Permet lors de la cration de la fiche de charger la liste des groupes||
// ||   Dans les quelles l'ordinateur ce trouve ainsi que charger la liste    ||
// ||   complete des groupes du domaine ou ce trouve l'ordinateur             ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|
var
  i : longword;
  j : integer;
  str : string;
  user : ARRAY[0..255] OF Char;
begin

  caption := caption + ' V'+StrLectureVersion;

// ****************************************************************************
// * On force l'affichage de la forme                                         *
// ****************************************************************************

  Show ;
  application.ProcessMessages ;

// ****************************************************************************
// * Affichage du nom de l'utilisateur                                        *
// ****************************************************************************

  i := 255;
  GetUserName(user,i);
  lbNomUtilisateur.Caption := user;

// ****************************************************************************
// * Affichage du nom de l'ordinateur                                         *
// ****************************************************************************

  i := 255;
  GetComputerName( user , i );
  lbNomPc.Caption := user;

// ****************************************************************************
// * Affichage du nom de domaine de l'ordinateur                              *
// ****************************************************************************

  i:=255;
  GetNomDomaine(str,i);
  lbNomDomaine.Caption := str;

// ****************************************************************************
// * Affichage du nom du BDC ou PDC                                           *
// ****************************************************************************

  str := '';
  application.ProcessMessages ;
  GetNomTousPdc('',lbNomDomaine.Caption ,str);
  LBNomBDC.Caption := str;

// ****************************************************************************
// * Si Serveur trouv rccuperration de la liste des groupes de l'oridnateur *
// ****************************************************************************

  lstListeGroupe.Items.Clear ;
  lstGroupeTotal.Items.Clear ;
  if str='' then
  begin
    LBNomBDC.Caption := '/!\ Erreur n''arrive pas  contacter le serveur /!\';
    lstListeGroupe.Enabled := false;
    lstGroupeTotal.Enabled := false;
    cmdAjoute.Enabled := false;
    cmdSupprimer.Enabled := false;
    exit;
  end;
  j := GetListeGroupeUtilisateur(LBNomBDC.Caption ,lbNomPc.Caption+'$',listegroupe);
  if j >-1 then
    for i := 0 to j-1 do lstListeGroupe.Items.Add(listegroupe[i].nom );

// ****************************************************************************
// * Rcuperration de la liste des groupes du serveur                         *
// ****************************************************************************

  GetListeGroupeGlobaux(LBNomBDC.Caption,listegroupeg) ;
  MiseAjourListeGroupe ;
end;

procedure TfrmMaitre.cmdAjouteClick(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdAjouteClick                                       |
// | _________________________________________________________________________ |
// ||   Permet d'ajouter le ou les groupes slectionns  l'ordinateur        ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i ,j : integer;

begin
  if lstGroupeTotal.SelCount = 0 then exit;
  if MessageDlg ('Etes vous sur de vouloir ajouter les groupes slectionns  ' + lbNomPc.Caption ,
                 mtConfirmation ,[mbyes,mbno],0) = mrno then exit;
  for i := 0 to lstGroupeTotal.Items.Count -1 do
    if lstGroupeTotal.Selected[i] then
    begin

// ****************************************************************************
// * Ajoute les groupes slectionns  l'ordinateur                           *
// ****************************************************************************

      j:= AjouteUtilisateurGroupe(LBNomBDC.Caption,lbNomPc.Caption +'$',lstGroupeTotal.Items[i]);
      if j = 0 then
        lstListeGroupe.Items.Add(lstGroupeTotal.Items[i]) else
        showmessage( 'Erreur ' + inttostr(j));
    end;
  MiseAjourListeGroupe ;
end;

procedure TfrmMaitre.cmdSupprimerClick(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdSupprimerClick                                    |
// | _________________________________________________________________________ |
// ||   Permet de supprimer le ou les groupes slectionns  l'ordinateur     ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i,j : integer;
begin
  if lstListeGroupe.SelCount = 0 then exit;
  if MessageDlg ('Etes vous sur de vouloir supprimer les groupes slectionns  ' + lbNomPc.Caption ,
                 mtConfirmation ,[mbyes,mbno],0) = mrno then exit;
  for i := lstListeGroupe.Items.Count -1 downto 0 do
    if lstListeGroupe.Selected[i] then
    begin

// ****************************************************************************
// * Supprime les groupes slectionns  l'ordinateur                         *
// ****************************************************************************

      j := SupprimeUtilisateurGroupe(LBNomBDC.Caption,lbNomPc.Caption +'$',lstListeGroupe.Items[i]);
      if j = 0 then
        lstListeGroupe.Items.Delete (i)
      else showmessage('Erreur ' + inttostr(j));
     end;
  MiseAjourListeGroupe ;
end;

procedure TfrmMaitre.filtreChange(Sender: TObject);
//  ___________________________________________________________________________
// | procedure TfrmMaitre.filtreChange                                         |
// | _________________________________________________________________________ |
// ||   Permet de raffraichir la liste des groupes en fonction du filtre      ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet crant l'action                                       ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  MiseAjourListeGroupe ;
end;

end.
